///////////////////////////////////////////////////////////////////////////////////////
// Author: Synactive, Inc. [1065 E. Hillsdale Blvd, Foster City, CA, 94404, USA]
// Email: support@guixt.com; sales@guixt.com; 
// Contact: 650.341.3310
// Version: 1.0.0.0
///////////////////////////////////////////////////////////////////////////////////////


DATA_TYPE_REF_ARY = {"CHAR":"C", "UNIT":"C", "LANG":"C", "CUKY":"C",
					"DATS":"D", "FLTP":"F", "TIMS":"T", "NUMC":"N",
					"QUAN":"P", "DEC":"P", "CURR":"P",
					"INT":"I", "INT1":"b", "INT2":"s", "INT4":"I"};

if(_transaction == "SE37"){
	
	if(!z_se37_display_structure_obj){
		pushbutton([TOOLBAR], "Get Structure Object", "?", {"process":se37GetStructureObject});
	}
	else {
		pushbutton([TOOLBAR], "Clear Structure Object", "?", {"process":se37Reset});
		
		clearscreen();
		
		textbox([0,0], [30,160], {"name":"z_se37_structure_obj_text"});
	}
}

//Function to reset SE37 related variables
function se37Reset(){
	set("V[z_se37*]", "");
}

//Function to get structure object from screen
function se37GetStructureObject(){
	
	onscreen "SAPLSD41.2100"
		set("V[z_se37_structure]", "&F[Structure]");
		var relrow = 1;
		var absrow = 1;
		var z_se37_component_ary = [];
		var z_se37_row_ary = [];
		
NEW_SCREEN:;		
		enter("/ScrollToLine=&V[absrow]", {"table":"T[SAPLSD41_TC0]"});
		
	onscreen "SAPLSD41.2100"
		gettableattribute("T[SAPLSD41_TC0]", {"firstvisiblerow":"FVisRow", "lastvisiblerow":"LVisRow", "lastrow":"LRow"});	
		relrow = 1;
NEW_ROW:;	
		if(absrow > LVisRow){
			goto NEW_SCREEN;
		}
	
		if(absrow > LRow){
			goto END_OF_TABLE;
		}
	
		z_se37_row_ary = [];
		set("V[cur_component]", "&cell[SAPLSD41_TC0,Component,&V[relrow]]");
		set("V[cur_typing_method]", "&cell[SAPLSD41_TC0,Typing Method,&V[relrow]]");
		set("V[cur_component_type]", "&cell[SAPLSD41_TC0,Component Type,&V[relrow]]");
		set("V[cur_data_type]", "&cell[SAPLSD41_TC0,Data Type,&V[relrow]]");
		set("V[cur_length]", "&cell[SAPLSD41_TC0,Length,&V[relrow]]");
		set("V[cur_decimal_pl]", "&cell[SAPLSD41_TC0,Decimal Pl,&V[relrow]]");
		set("V[cur_short_desc]", "&cell[SAPLSD41_TC0,Short Description,&V[relrow]]");
	
		z_se37_row_ary.push(cur_component);
		z_se37_row_ary.push(cur_typing_method);
		z_se37_row_ary.push(cur_component_type);
		z_se37_row_ary.push(cur_data_type);
		z_se37_row_ary.push(cur_length);
		z_se37_row_ary.push(cur_decimal_pl);
		z_se37_row_ary.push(cur_short_desc);
	
		z_se37_component_ary.push(z_se37_row_ary);
	
		relrow++;
		absrow++;
		goto NEW_ROW;
END_OF_TABLE:;

		z_se37_display_structure_obj = true;

		var z_se37_result_struct_ary = setStructureObject(z_se37_structure,z_se37_component_ary);
		
		for(var struct in z_se37_result_struct_ary){			
			tmp_str = z_se37_result_struct_ary[struct];
			
			if(struct==0)
				copytext({"totext":"z_se37_structure_obj_text", "fromstring":"tmp_str"});
			else
				copytext({"totext":"z_se37_structure_obj_text", "fromstring":"tmp_str", "appendline":true});

		}
		
		enter("/ScrollToLine=1", {"table":"T[SAPLSD41_TC0]"});
}

//Function to organize component array to become structure object detail
function setStructureObject(structure,component_ary){
	var result_ary = [];
	var component_str = "";
	
	println("component_ary.length=\n"+component_ary.length+"");

	
	result_ary.push("\tvar z_" + structure + " = {");
	result_ary.push("\t\tname:'" + structure + "',");
	result_ary.push("\t\tcomponents:[");
	
	for(var i=0; i<component_ary.length; i++){
		component_str = "\t\t\t{ name:'" + component_ary[i][0] + 
						"', \tlength:" + component_ary[i][4] + 
						",\tdecimalpl:" + component_ary[i][5] + 
						",\ttype:'" + DATA_TYPE_REF_ARY[component_ary[i][3]] + 
						"' }" + ((i!=component_ary.length-1)?",":"") +
						"\t" + ((component_ary[i][3]=="CHAR")?"\t\t\t":("/** " + component_ary[i][3] + " **/\t\t")) + 
						"//" + component_ary[i][6];
		
		result_ary.push(component_str );
	}
	
	result_ary.push("\t\t]");
	result_ary.push("\t};");
	
	return	result_ary;
}


